<?php
/*
+--------------------------------------------------------------------------
|   IBITZY Meganova Plugin
|   =============================================
|   Web: http://www.ipbtracker.eu/index.php?showforum=26
|	By: jaggi
|	Created: 15/09/06
+---------------------------------------------------------------------------
| Setup various parts of the plugin for the site
+--------------------------------------------------------------------------
*/

//--------------------------------
// Start class
//--------------------------------

class meganova
{
	/**
	* SETUP VARS
	*
	* to_spider = URL to page you wish to index
	* tinfo = the details page of the torrent
	* tinfo_url = full url of site to torrent details page
	* dl_link = full download url to torrent
	* dl_extra = some sites require trailing slashes or .torrent after the url, here u can do that
	* conf = this loads the conf class, don't edit
	*/
	
	var $to_spider	= 'http://www.meganova.org/order-date.html';
	var $tinfo		= '/details/';
	var $tinfo_url	= 'http://www.meganova.org/details/';
	var $dl_link	= 'http://www.meganova.org/torrent/';
	var $dl_extra	= '';
	var $conf		= '';

	/*-------------------------------------------------------------------------*/
	// Main Match
	// > Get full url and torrent id 
	/*-------------------------------------------------------------------------*/ 
	
	function main_match( $file )
	{
		preg_match_all( "#<a href=\"{$this->tinfo}(.+?).html\">(.+?)</a>#ise",	$file,	$out ); 
		foreach ( $out['1'] as $k )
		{
			$return[ $k ] = array( 'url' => $this->tinfo_url . $k . '.html', 'id' => $k );
		}
		return $return;
	}
	
	/*-------------------------------------------------------------------------*/
	// Match Name
	// > Get torrent name
	/*-------------------------------------------------------------------------*/ 
	
	function match_name( $file )
	{
		@preg_match( "#<h1 .+?>(.+?)</h1>#", $file,	$out );
		return $out[1];
	}
	
	/*-------------------------------------------------------------------------*/
	// Process Cat
	// > Get category on site
	/*-------------------------------------------------------------------------*/ 	
	
	function process_cat( $file )
	{
		@preg_match( "#<td> <a href=\"/cat/(\d+).+?\">#", $file, $out ); 
		return $out[1];
	}
	
	/*-------------------------------------------------------------------------*/
	// Process sub
	// > Get torrent sub category
	/*-------------------------------------------------------------------------*/ 	
	
	function process_sub( $file )
	{
		return;
	}
	
	/*-------------------------------------------------------------------------*/
	// Process Magnet
	// > Get magnet link
	/*-------------------------------------------------------------------------*/ 
	
	function process_magnet( $file )
	{
		@preg_match( "#href=\"magnet:(.+?)\">#",	$file,	$out ); 
		return  'magnet:'.$out[1];
	}
	
	/*-------------------------------------------------------------------------*/
	// Cat Code Extra
	// > Process and match site category with global categories
	/*-------------------------------------------------------------------------*/ 
		
	function cat_code_extra( $cat="", $sub="" )
	{
		//-----------------------------------------
		// Match Array
		//-----------------------------------------
		//============================================================================================
		//  MEGANOVA ID => 'category name(no functional use)', main category array, 
		//============================================================================================
		
		$pluggin_cats = array( 
								1 => array( 'Movies', $this->conf['cats'][4][0] ),
								2 => array( 'Series', $this->conf['cats'][7][0] ),
								3 => array( 'Music', $this->conf['cats'][5][0] ),
								4 => array( 'Games', $this->conf['cats'][3][0] ),
								5 => array( 'Software', $this->conf['cats'][6][0] ),
								6 => array( 'Anime', $this->conf['cats'][1][0] ),
								7 => array( 'Misc', $this->conf['cats'][8][0] ),
							  );
	
		//-----------------------------------------
		// Check if we have match or set as other
		//  > Return cat id to class
		//-----------------------------------------
										
		$return_cat = !$pluggin_cats[ $cat ] ? $this->conf['cats'][8][0] : $pluggin_cats[ $cat ][1];
		return array( 'cat' => $return_cat, 'sub' => '' );
	}

	/*-------------------------------------------------------------------------*/
	// Process Download
	// > Setup the download url from where the torrents are downloaded
	/*-------------------------------------------------------------------------*/
	
	function process_download( $dlurl, $tinfo )
	{
		//---------------------------------------------
		// Do preg_match cus url involves torrent hash
		//---------------------------------------------
			
		@preg_match( "#href=\"/torrent/(.+?)\">#",	$dlurl,	$out ); 
			
		//-----------------------------------------
		// Construct and return url
		//-----------------------------------------
		
		$dlurl = $this->dl_link . $out[1];
		return $dlurl;
	}
}
?>